<?php

/*******************************************************************************/ 
/* HACKERS 2 LOCATION:  Addon on Script for BlockHosts                         */ 
/* ============================================                                */ 
/*                                                                             */ 
/* Copyright (c) 2005 by Kenneth Kline (kenneth.kline@gmail.com)               */ 
/* http://www.kennethkline.com                                                 */ 
/*                                                                             */ 
/*******************************************************************************/ 

/* This library is free software; you can redistribute it and/or               */
/* modify it under the terms of the GNU General Public                         */
/* License as published by the Free Software Foundation; either                */
/* version 2.1 of the License, or (at your option) any later version.          */
/*                                                                             */
/* This library is distributed in the hope that it will be useful,             */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/* Lesser General Public License for more details.                             */
/*                                                                             */
/* You should have received a copy of the GNU General Public                   */
/* License along with this library; if not, write to the Free Software         */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                             */

# VARIABLES THAT ARE SPECIFIC TO YOUR WEBSITE
# YOUR WEBSITE NAME
$sitename = "MYWEBSITE.COM";

# GOOGLE MAP
# SIGN UP FOR A KEY AT: http://www.google.com/apis/maps/signup.html
$api_key = "INSERT_YOUR_KEY_HERE_OBTAIN_FROM_GOOGLE_FOR_FREE";

# USING THE FREE GEOLITECITY.DAT FROM MaxMind
# DOWNLOAD AT:  http://www.maxmind.com/download/geoip/database/GeoLiteCity.dat.gz
$geoDB = "/usr/local/share/GeoIP/GeoLiteCity.dat";

#THE NUMBER OF INTRUSIONS TO PLOT STARTING WITH MOST RECENT
$show_last = 30;

echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">";
echo "<html xmlns=\"http://www.w3.org/1999/xhtml\">";
echo "<head>";
echo "<script src=\"http://maps.google.com/maps?file=api&v=1&key=$api_key\" type=\"text/javascript\"></script>";
echo "<script type=\"text/javascript\">\n";
echo "//<![CDATA[\n";

## ONLOAD ROUTINE
echo "function onLoad() {\n";
echo "  // The Basics\n";
echo "  //\n";
echo "  // Creates a map and centers it the Entire World.\n";
echo "  var baseIcon = new GIcon();\n";
echo "  baseIcon.shadow = \"http://www.google.com/mapfiles/shadow50.png\"\n";
echo "  baseIcon.iconSize = new GSize(20, 34);\n";
echo "  baseIcon.shadowSize = new GSize(37, 34);\n";
echo "  baseIcon.iconAnchor = new GPoint(9, 34);\n";
echo "  baseIcon.infoWindowAnchor = new GPoint(9, 2);\n";
echo "  baseIcon.infoShadowAnchor = new GPoint(18, 25);\n";
      
echo "  var map = new GMap(document.getElementById(\"map\"));\n";
echo "  map.addControl(new GSmallMapControl());\n";
echo "  map.addControl(new GMapTypeControl());\n";
echo "  map.centerAndZoom(new GPoint(0.0000, 0.0000), 15);\n";

echo "  // Creates a marker whose info window displays the letter corresponding to\n";
echo "  // the given index\n";
echo "  function createMarker(point, index) {\n";
echo "     // Create a lettered icon for this point using our icon class from above\n";
echo "     var letter = String.fromCharCode(\"A\".charCodeAt(0) + index);\n";
echo "     var icon = new GIcon(baseIcon);\n";
echo "     icon.image = \"http://www.google.com/mapfiles/marker\" + letter + \".png\";\n";
echo "     var marker = new GMarker(point, icon);\n";
      
echo "     // Show this marker's index in the info window when it is clicked\n";
echo "     var html = \"Marker <b>\" + letter + \"</b>\";\n";
echo "     GEvent.addListener(marker, \"click\", function() {\n";
echo "        marker.openInfoWindowHtml(html);\n";
echo "     });\n";
      
echo "     return marker;\n";
echo "  }\n";


   include("geoipcity.inc");
   $gi = geoip_open("$geoDB",GEOIP_STANDARD);

   $lines = file('/etc/hosts.deny');  
   $l_count = count($lines);  
   $j = 0;
   for($i = 0; $i< $l_count; $i++) {  
      if ( ereg("^#bh: ip:", $lines[$i]) ) {
   	     #print "$lines[$x]<br>\n";
   	     $lines[$i] = ereg_replace(" ", "", $lines[$i]);
      	 list( $bh, $iplabel, $ip, $attempts, $date) = split('[:]', $lines[$i]);
      	 #print "[$ip], [$attempts], [$date]<br>\n";
      	 list( $year, $month, $day, $hour, $minute) = split('[-]', $date);
      	 $record = geoip_record_by_addr($gi, $ip);
      	 $j++;
      	 if ( $j <= $show_last ){
      	    if ( $record->longitude ) { $long = sprintf("%01.4f", $record->longitude); }
      	    if ( $record->latitude ) { $lat = sprintf("%01.4f", $record->latitude); }
      	    $html_data .= "<tr>\n
		       <td width=\"50\">$j</td>\n
		       <td width=\"150\">$month/$day/$year $hour:$minute</td>\n
		       <td width=\"100\">$ip</td>\n
		       <td width=\"200\">$record->country_name</td>\n
		       <td width=\"200\">$record->city</td>\n
		       <td width=\"60\">$record->region</td>\n
		       <td width=\"70\">$long</td>\n
		       <td width=\"70\">$lat</td>\n
	           </tr>\n";
 		       #<td width=\"81\">$record->area_code</td>\n     	 
            if ( $lat && $long ) {
               // Add locations
               echo "var point = new GPoint(parseFloat($long), parseFloat($lat));\n";
               echo "var marker = new GMarker(point);\n";
               #echo "var marker = createMarker(point, $j);\n";
               echo "map.addOverlay(marker);\n";
            }
         }
         $lat = "";
         $long = "";
      }
   }   
echo "}\n";
echo "//]]>\n";
echo "</script>\n";
## END ONLOAD ROUTINE


echo "</head>\n";
echo "<center>";
echo "<body onload=\"onLoad()\">\n";

echo "<div align=\"center\">\n";
echo "<table border=\"0\" width=\"900\" id=\"table_main\">\n";
echo "<tr>";
echo "<td colspan=\"11\" align=\"center\"><b><font size=\"5\">\n";
echo "INTRUSION ATTEMPTS AT $sitename\n";
echo "</font></b></td>\n";
echo "</tr><tr>";
echo "<td colspan=\"11\" height=\"31\">";
echo "<div id=\"map\" style=\"width: 900px; height: 450px\"></div>\n";
echo "</td></tr>\n";
echo "<tr>\n
		    <td width=\"50\"><b>CNT</b></td>\n
		    <td width=\"150\"><b>DATE</b></td>\n
		    <td width=\"100\"><b>IP ADDRESS</b></td>\n
		    <td width=\"200\"><b>COUNTRY NAME</b></td>\n
		    <td width=\"200\"><b>CITY</b></td>\n
		    <td width=\"60\"><b>REGION</b></td>\n
		    <td width=\"70\"><b>LONGITUDE</b></td>\n
		    <td width=\"70\"><b>LATITUDE</b></td>\n
	        </tr>\n";

echo "$html_data";	#PRINT THE GENERATED HTML
echo "</table>\n";
echo "<hr>";
## DO NOT REMOVE THE FOLLOWING LINE
echo "Copyright  2005 <b>KennethKline.com</b>\n";

geoip_close($gi);
   
echo "</body>";
echo "</html>";	

?> 
